Merge branch 'sb/submodule-helper-list-signal-unmatch-via-exit-status'
[git/gitster.git] / git-submodule.sh
blobfadbe5d3e0181faf6f3b972723387e242fd6a0a1
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
34 command=
35 branch=
36 force=
37 reference=
38 cached=
39 recursive=
40 init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
49 # Resolve a path to be relative to another path. This is intended for
50 # converting submodule paths when git-submodule is run in a subdirectory
51 # and only handles paths where the directory separator is '/'.
53 # The output is the first argument as a path relative to the second argument,
54 # which defaults to $wt_prefix if it is omitted.
55 relative_path ()
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
63 while test -n "$curdir"
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
70 esac
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
79 done
81 echo "$result$target"
84 die_if_unmatched ()
86 if test "$1" = "#unmatched"
87 then
88 exit 1
93 # Print a submodule configuration setting
95 # $1 = submodule name
96 # $2 = option name
97 # $3 = default value
99 # Checks in the usual git-config places first (for overrides),
100 # otherwise it falls back on .gitmodules. This allows you to
101 # distribute project-wide defaults in .gitmodules, while still
102 # customizing individual repositories if necessary. If the option is
103 # not in .gitmodules either, print a default value.
105 get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
114 printf '%s' "${value:-$default}"
117 isnumber()
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
122 # Sanitize the local git environment for use within a submodule. We
123 # can't simply use clear_local_git_env since we want to preserve some
124 # of the settings from GIT_CONFIG_PARAMETERS.
125 sanitize_submodule_env()
127 save_config=$GIT_CONFIG_PARAMETERS
128 clear_local_git_env
129 GIT_CONFIG_PARAMETERS=$save_config
130 export GIT_CONFIG_PARAMETERS
134 # Add a new submodule to the working tree, .gitmodules and the index
136 # $@ = repo path
138 # optional branch is stored in global branch variable
140 cmd_add()
142 # parse $args after "submodule ... add".
143 reference_path=
144 while test $# -ne 0
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
152 -f | --force)
153 force=$1
155 -q|--quiet)
156 GIT_QUIET=1
158 --reference)
159 case "$2" in '') usage ;; esac
160 reference_path=$2
161 shift
163 --reference=*)
164 reference_path="${1#--reference=}"
166 --name)
167 case "$2" in '') usage ;; esac
168 custom_name=$2
169 shift
171 --depth)
172 case "$2" in '') usage ;; esac
173 depth="--depth=$2"
174 shift
176 --depth=*)
177 depth=$1
180 shift
181 break
184 usage
187 break
189 esac
190 shift
191 done
193 if test -n "$reference_path"
194 then
195 is_absolute_path "$reference_path" ||
196 reference_path="$wt_prefix$reference_path"
198 reference="--reference=$reference_path"
201 repo=$1
202 sm_path=$2
204 if test -z "$sm_path"; then
205 sm_path=$(printf '%s\n' "$repo" |
206 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
209 if test -z "$repo" || test -z "$sm_path"; then
210 usage
213 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
215 # assure repo is absolute or relative to parent
216 case "$repo" in
217 ./*|../*)
218 test -z "$wt_prefix" ||
219 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
221 # dereference source url relative to parent's url
222 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
224 *:*|/*)
225 # absolute url
226 realrepo=$repo
229 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
231 esac
233 # normalize path:
234 # multiple //; leading ./; /./; /../; trailing /
235 sm_path=$(printf '%s/\n' "$sm_path" |
236 sed -e '
237 s|//*|/|g
238 s|^\(\./\)*||
239 s|/\(\./\)*|/|g
240 :start
241 s|\([^/]*\)/\.\./||
242 tstart
243 s|/*$||
245 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
246 die "$(eval_gettext "'\$sm_path' already exists in the index")"
248 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
249 then
250 eval_gettextln "The following path is ignored by one of your .gitignore files:
251 \$sm_path
252 Use -f if you really want to add it." >&2
253 exit 1
256 if test -n "$custom_name"
257 then
258 sm_name="$custom_name"
259 else
260 sm_name="$sm_path"
263 # perhaps the path exists and is already a git repo, else clone it
264 if test -e "$sm_path"
265 then
266 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
267 then
268 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
269 else
270 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
273 else
274 if test -d ".git/modules/$sm_name"
275 then
276 if test -z "$force"
277 then
278 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
279 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
280 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
281 echo >&2 " $realrepo"
282 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
283 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
284 else
285 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
288 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
290 sanitize_submodule_env
291 cd "$sm_path" &&
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 esac
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
299 git config submodule."$sm_name".url "$realrepo"
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
304 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
306 if test -n "$branch"
307 then
308 git config -f .gitmodules submodule."$sm_name".branch "$branch"
309 fi &&
310 git add --force .gitmodules ||
311 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
315 # Execute an arbitrary command sequence in each checked out
316 # submodule
318 # $@ = command to execute
320 cmd_foreach()
322 # parse $args after "submodule ... foreach".
323 while test $# -ne 0
325 case "$1" in
326 -q|--quiet)
327 GIT_QUIET=1
329 --recursive)
330 recursive=1
333 usage
336 break
338 esac
339 shift
340 done
342 toplevel=$(pwd)
344 # dup stdin so that it can be restored when running the external
345 # command in the subshell (and a recursive call to this function)
346 exec 3<&0
349 git submodule--helper list --prefix "$wt_prefix" ||
350 echo "#unmatched"
352 while read mode sha1 stage sm_path
354 die_if_unmatched "$mode"
355 if test -e "$sm_path"/.git
356 then
357 displaypath=$(relative_path "$prefix$sm_path")
358 say "$(eval_gettext "Entering '\$displaypath'")"
359 name=$(git submodule--helper name "$sm_path")
361 prefix="$prefix$sm_path/"
362 sanitize_submodule_env
363 cd "$sm_path" &&
364 sm_path=$(relative_path "$sm_path") &&
365 # we make $path available to scripts ...
366 path=$sm_path &&
367 if test $# -eq 1
368 then
369 eval "$1"
370 else
371 "$@"
372 fi &&
373 if test -n "$recursive"
374 then
375 cmd_foreach "--recursive" "$@"
377 ) <&3 3<&- ||
378 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
380 done
384 # Register submodules in .git/config
386 # $@ = requested paths (default to all)
388 cmd_init()
390 # parse $args after "submodule ... init".
391 while test $# -ne 0
393 case "$1" in
394 -q|--quiet)
395 GIT_QUIET=1
398 shift
399 break
402 usage
405 break
407 esac
408 shift
409 done
411 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
415 # Unregister submodules from .git/config and remove their work tree
417 # $@ = requested paths (use '.' to deinit all submodules)
419 cmd_deinit()
421 # parse $args after "submodule ... deinit".
422 deinit_all=
423 while test $# -ne 0
425 case "$1" in
426 -f|--force)
427 force=$1
429 -q|--quiet)
430 GIT_QUIET=1
432 --all)
433 deinit_all=t
436 shift
437 break
440 usage
443 break
445 esac
446 shift
447 done
449 if test -n "$deinit_all" && test "$#" -ne 0
450 then
451 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
452 usage
454 if test $# = 0 && test -z "$deinit_all"
455 then
456 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
460 git submodule--helper list --prefix "$wt_prefix" "$@" ||
461 echo "#unmatched"
463 while read mode sha1 stage sm_path
465 die_if_unmatched "$mode"
466 name=$(git submodule--helper name "$sm_path") || exit
468 displaypath=$(relative_path "$sm_path")
470 # Remove the submodule work tree (unless the user already did it)
471 if test -d "$sm_path"
472 then
473 # Protect submodules containing a .git directory
474 if test -d "$sm_path/.git"
475 then
476 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
477 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
480 if test -z "$force"
481 then
482 git rm -qn "$sm_path" ||
483 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
485 rm -rf "$sm_path" &&
486 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
487 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
490 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
492 # Remove the .git/config entries (unless the user already did it)
493 if test -n "$(git config --get-regexp submodule."$name\.")"
494 then
495 # Remove the whole section so we have a clean state when
496 # the user later decides to init this submodule again
497 url=$(git config submodule."$name".url)
498 git config --remove-section submodule."$name" 2>/dev/null &&
499 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
501 done
504 is_tip_reachable () (
505 sanitize_submodule_env &&
506 cd "$1" &&
507 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
508 test -z "$rev"
511 fetch_in_submodule () (
512 sanitize_submodule_env &&
513 cd "$1" &&
514 case "$2" in
516 git fetch ;;
518 git fetch $(get_default_remote) "$2" ;;
519 esac
523 # Update each submodule path to correct revision, using clone and checkout as needed
525 # $@ = requested paths (default to all)
527 cmd_update()
529 # parse $args after "submodule ... update".
530 while test $# -ne 0
532 case "$1" in
533 -q|--quiet)
534 GIT_QUIET=1
536 -i|--init)
537 init=1
539 --remote)
540 remote=1
542 -N|--no-fetch)
543 nofetch=1
545 -f|--force)
546 force=$1
548 -r|--rebase)
549 update="rebase"
551 --reference)
552 case "$2" in '') usage ;; esac
553 reference="--reference=$2"
554 shift
556 --reference=*)
557 reference="$1"
559 -m|--merge)
560 update="merge"
562 --recursive)
563 recursive=1
565 --checkout)
566 update="checkout"
568 --depth)
569 case "$2" in '') usage ;; esac
570 depth="--depth=$2"
571 shift
573 --depth=*)
574 depth=$1
576 -j|--jobs)
577 case "$2" in '') usage ;; esac
578 jobs="--jobs=$2"
579 shift
581 --jobs=*)
582 jobs=$1
585 shift
586 break
589 usage
592 break
594 esac
595 shift
596 done
598 if test -n "$init"
599 then
600 cmd_init "--" "$@" || return
604 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
605 ${wt_prefix:+--prefix "$wt_prefix"} \
606 ${prefix:+--recursive-prefix "$prefix"} \
607 ${update:+--update "$update"} \
608 ${reference:+--reference "$reference"} \
609 ${depth:+--depth "$depth"} \
610 ${jobs:+$jobs} \
611 "$@" || echo "#unmatched"
612 } | {
613 err=
614 while read mode sha1 stage just_cloned sm_path
616 die_if_unmatched "$mode"
618 name=$(git submodule--helper name "$sm_path") || exit
619 url=$(git config submodule."$name".url)
620 branch=$(get_submodule_config "$name" branch master)
621 if ! test -z "$update"
622 then
623 update_module=$update
624 else
625 update_module=$(git config submodule."$name".update)
626 if test -z "$update_module"
627 then
628 update_module="checkout"
632 displaypath=$(relative_path "$prefix$sm_path")
634 if test $just_cloned -eq 1
635 then
636 subsha1=
637 update_module=checkout
638 else
639 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
640 git rev-parse --verify HEAD) ||
641 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
644 if test -n "$remote"
645 then
646 if test -z "$nofetch"
647 then
648 # Fetch remote before determining tracking $sha1
649 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
650 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
652 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
653 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
654 git rev-parse --verify "${remote_name}/${branch}") ||
655 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
658 if test "$subsha1" != "$sha1" || test -n "$force"
659 then
660 subforce=$force
661 # If we don't already have a -f flag and the submodule has never been checked out
662 if test -z "$subsha1" && test -z "$force"
663 then
664 subforce="-f"
667 if test -z "$nofetch"
668 then
669 # Run fetch only if $sha1 isn't present or it
670 # is not reachable from a ref.
671 is_tip_reachable "$sm_path" "$sha1" ||
672 fetch_in_submodule "$sm_path" ||
673 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
675 # Now we tried the usual fetch, but $sha1 may
676 # not be reachable from any of the refs
677 is_tip_reachable "$sm_path" "$sha1" ||
678 fetch_in_submodule "$sm_path" "$sha1" ||
679 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
682 must_die_on_failure=
683 case "$update_module" in
684 checkout)
685 command="git checkout $subforce -q"
686 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
687 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
689 rebase)
690 command="git rebase"
691 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
692 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
693 must_die_on_failure=yes
695 merge)
696 command="git merge"
697 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
698 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
699 must_die_on_failure=yes
702 command="${update_module#!}"
703 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
704 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
705 must_die_on_failure=yes
708 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
709 esac
711 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
712 then
713 say "$say_msg"
714 elif test -n "$must_die_on_failure"
715 then
716 die_with_status 2 "$die_msg"
717 else
718 err="${err};$die_msg"
719 continue
723 if test -n "$recursive"
724 then
726 prefix=$(relative_path "$prefix$sm_path/")
727 wt_prefix=
728 sanitize_submodule_env
729 cd "$sm_path" &&
730 eval cmd_update
732 res=$?
733 if test $res -gt 0
734 then
735 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
736 if test $res -eq 1
737 then
738 err="${err};$die_msg"
739 continue
740 else
741 die_with_status $res "$die_msg"
745 done
747 if test -n "$err"
748 then
749 OIFS=$IFS
750 IFS=';'
751 for e in $err
753 if test -n "$e"
754 then
755 echo >&2 "$e"
757 done
758 IFS=$OIFS
759 exit 1
764 set_name_rev () {
765 revname=$( (
766 sanitize_submodule_env
767 cd "$1" && {
768 git describe "$2" 2>/dev/null ||
769 git describe --tags "$2" 2>/dev/null ||
770 git describe --contains "$2" 2>/dev/null ||
771 git describe --all --always "$2"
774 test -z "$revname" || revname=" ($revname)"
777 # Show commit summary for submodules in index or working tree
779 # If '--cached' is given, show summary between index and given commit,
780 # or between working tree and given commit
782 # $@ = [commit (default 'HEAD'),] requested paths (default all)
784 cmd_summary() {
785 summary_limit=-1
786 for_status=
787 diff_cmd=diff-index
789 # parse $args after "submodule ... summary".
790 while test $# -ne 0
792 case "$1" in
793 --cached)
794 cached="$1"
796 --files)
797 files="$1"
799 --for-status)
800 for_status="$1"
802 -n|--summary-limit)
803 summary_limit="$2"
804 isnumber "$summary_limit" || usage
805 shift
807 --summary-limit=*)
808 summary_limit="${1#--summary-limit=}"
809 isnumber "$summary_limit" || usage
812 shift
813 break
816 usage
819 break
821 esac
822 shift
823 done
825 test $summary_limit = 0 && return
827 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
828 then
829 head=$rev
830 test $# = 0 || shift
831 elif test -z "$1" || test "$1" = "HEAD"
832 then
833 # before the first commit: compare with an empty tree
834 head=$(git hash-object -w -t tree --stdin </dev/null)
835 test -z "$1" || shift
836 else
837 head="HEAD"
840 if [ -n "$files" ]
841 then
842 test -n "$cached" &&
843 die "$(gettext "The --cached option cannot be used with the --files option")"
844 diff_cmd=diff-files
845 head=
848 cd_to_toplevel
849 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
850 # Get modified modules cared by user
851 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
852 sane_egrep '^:([0-7]* )?160000' |
853 while read mod_src mod_dst sha1_src sha1_dst status sm_path
855 # Always show modules deleted or type-changed (blob<->module)
856 if test "$status" = D || test "$status" = T
857 then
858 printf '%s\n' "$sm_path"
859 continue
861 # Respect the ignore setting for --for-status.
862 if test -n "$for_status"
863 then
864 name=$(git submodule--helper name "$sm_path")
865 ignore_config=$(get_submodule_config "$name" ignore none)
866 test $status != A && test $ignore_config = all && continue
868 # Also show added or modified modules which are checked out
869 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
870 printf '%s\n' "$sm_path"
871 done
874 test -z "$modules" && return
876 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
877 sane_egrep '^:([0-7]* )?160000' |
878 cut -c2- |
879 while read mod_src mod_dst sha1_src sha1_dst status name
881 if test -z "$cached" &&
882 test $sha1_dst = 0000000000000000000000000000000000000000
883 then
884 case "$mod_dst" in
885 160000)
886 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
888 100644 | 100755 | 120000)
889 sha1_dst=$(git hash-object $name)
891 000000)
892 ;; # removed
894 # unexpected type
895 eval_gettextln "unexpected mode \$mod_dst" >&2
896 continue ;;
897 esac
899 missing_src=
900 missing_dst=
902 test $mod_src = 160000 &&
903 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
904 missing_src=t
906 test $mod_dst = 160000 &&
907 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
908 missing_dst=t
910 display_name=$(relative_path "$name")
912 total_commits=
913 case "$missing_src,$missing_dst" in
915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
918 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
920 t,t)
921 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
924 errmsg=
925 total_commits=$(
926 if test $mod_src = 160000 && test $mod_dst = 160000
927 then
928 range="$sha1_src...$sha1_dst"
929 elif test $mod_src = 160000
930 then
931 range=$sha1_src
932 else
933 range=$sha1_dst
935 GIT_DIR="$name/.git" \
936 git rev-list --first-parent $range -- | wc -l
938 total_commits=" ($(($total_commits + 0)))"
940 esac
942 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
943 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
944 if test $status = T
945 then
946 blob="$(gettext "blob")"
947 submodule="$(gettext "submodule")"
948 if test $mod_dst = 160000
949 then
950 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
951 else
952 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
954 else
955 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
957 if test -n "$errmsg"
958 then
959 # Don't give error msg for modification whose dst is not submodule
960 # i.e. deleted or changed to blob
961 test $mod_dst = 160000 && echo "$errmsg"
962 else
963 if test $mod_src = 160000 && test $mod_dst = 160000
964 then
965 limit=
966 test $summary_limit -gt 0 && limit="-$summary_limit"
967 GIT_DIR="$name/.git" \
968 git log $limit --pretty='format: %m %s' \
969 --first-parent $sha1_src...$sha1_dst
970 elif test $mod_dst = 160000
971 then
972 GIT_DIR="$name/.git" \
973 git log --pretty='format: > %s' -1 $sha1_dst
974 else
975 GIT_DIR="$name/.git" \
976 git log --pretty='format: < %s' -1 $sha1_src
978 echo
980 echo
981 done
984 # List all submodules, prefixed with:
985 # - submodule not initialized
986 # + different revision checked out
988 # If --cached was specified the revision in the index will be printed
989 # instead of the currently checked out revision.
991 # $@ = requested paths (default to all)
993 cmd_status()
995 # parse $args after "submodule ... status".
996 while test $# -ne 0
998 case "$1" in
999 -q|--quiet)
1000 GIT_QUIET=1
1002 --cached)
1003 cached=1
1005 --recursive)
1006 recursive=1
1009 shift
1010 break
1013 usage
1016 break
1018 esac
1019 shift
1020 done
1023 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1024 echo "#unmatched"
1026 while read mode sha1 stage sm_path
1028 die_if_unmatched "$mode"
1029 name=$(git submodule--helper name "$sm_path") || exit
1030 url=$(git config submodule."$name".url)
1031 displaypath=$(relative_path "$prefix$sm_path")
1032 if test "$stage" = U
1033 then
1034 say "U$sha1 $displaypath"
1035 continue
1037 if test -z "$url" ||
1039 ! test -d "$sm_path"/.git &&
1040 ! test -f "$sm_path"/.git
1042 then
1043 say "-$sha1 $displaypath"
1044 continue;
1046 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1047 then
1048 set_name_rev "$sm_path" "$sha1"
1049 say " $sha1 $displaypath$revname"
1050 else
1051 if test -z "$cached"
1052 then
1053 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1055 set_name_rev "$sm_path" "$sha1"
1056 say "+$sha1 $displaypath$revname"
1059 if test -n "$recursive"
1060 then
1062 prefix="$displaypath/"
1063 sanitize_submodule_env
1064 wt_prefix=
1065 cd "$sm_path" &&
1066 eval cmd_status
1067 ) ||
1068 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1070 done
1073 # Sync remote urls for submodules
1074 # This makes the value for remote.$remote.url match the value
1075 # specified in .gitmodules.
1077 cmd_sync()
1079 while test $# -ne 0
1081 case "$1" in
1082 -q|--quiet)
1083 GIT_QUIET=1
1084 shift
1086 --recursive)
1087 recursive=1
1088 shift
1091 shift
1092 break
1095 usage
1098 break
1100 esac
1101 done
1102 cd_to_toplevel
1104 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1105 echo "#unmatched"
1107 while read mode sha1 stage sm_path
1109 die_if_unmatched "$mode"
1110 name=$(git submodule--helper name "$sm_path")
1111 url=$(git config -f .gitmodules --get submodule."$name".url)
1113 # Possibly a url relative to parent
1114 case "$url" in
1115 ./*|../*)
1116 # rewrite foo/bar as ../.. to find path from
1117 # submodule work tree to superproject work tree
1118 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1119 # guarantee a trailing /
1120 up_path=${up_path%/}/ &&
1121 # path from submodule work tree to submodule origin repo
1122 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1123 # path from superproject work tree to submodule origin repo
1124 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1127 sub_origin_url="$url"
1128 super_config_url="$url"
1130 esac
1132 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1133 then
1134 displaypath=$(relative_path "$prefix$sm_path")
1135 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1136 git config submodule."$name".url "$super_config_url"
1138 if test -e "$sm_path"/.git
1139 then
1141 sanitize_submodule_env
1142 cd "$sm_path"
1143 remote=$(get_default_remote)
1144 git config remote."$remote".url "$sub_origin_url"
1146 if test -n "$recursive"
1147 then
1148 prefix="$prefix$sm_path/"
1149 eval cmd_sync
1154 done
1157 # This loop parses the command line arguments to find the
1158 # subcommand name to dispatch. Parsing of the subcommand specific
1159 # options are primarily done by the subcommand implementations.
1160 # Subcommand specific options such as --branch and --cached are
1161 # parsed here as well, for backward compatibility.
1163 while test $# != 0 && test -z "$command"
1165 case "$1" in
1166 add | foreach | init | deinit | update | status | summary | sync)
1167 command=$1
1169 -q|--quiet)
1170 GIT_QUIET=1
1172 -b|--branch)
1173 case "$2" in
1175 usage
1177 esac
1178 branch="$2"; shift
1180 --cached)
1181 cached="$1"
1184 break
1187 usage
1190 break
1192 esac
1193 shift
1194 done
1196 # No command word defaults to "status"
1197 if test -z "$command"
1198 then
1199 if test $# = 0
1200 then
1201 command=status
1202 else
1203 usage
1207 # "-b branch" is accepted only by "add"
1208 if test -n "$branch" && test "$command" != add
1209 then
1210 usage
1213 # "--cached" is accepted only by "status" and "summary"
1214 if test -n "$cached" && test "$command" != status && test "$command" != summary
1215 then
1216 usage
1219 "cmd_$command" "$@"